#include "Ballet128128_coreE.h"

void BalletGenRK_128_128_ENC(u8i * Rk, u8i * K)
{
	u64i i;
	u64i  k0, k1;
	u64i *p = (u64i *)Rk;
	k0 = *((u64i *)K);
	k1 = *((u64i *)(K + 8));
	k0 = SWAP64(k0);
	k1 = SWAP64(k1);

	for (i = 0; i < RoundBallet128128; i += 2)  
	{
		*p = k0;
		k0 ^= ROTL64(k1, 3) ^ ROTL64(k1, 5) ^ i;
		*(p + 1) = k1;
		k1 ^= ROTL64(k0, 3) ^ ROTL64(k0, 5) ^ (i + 1);
		p += 2;
	} 
}


void Ballet128128EncDataS(unsigned char *out, unsigned char *pt, unsigned char *rk)
{
	int i;
	u32i t0;
	u32i *trk = (u32i *)rk;
	u32i a = *((u32i *)pt);
	u32i b = *((u32i *)(pt + 4));
	u32i c = *((u32i *)(pt + 8));
	u32i d = *((u32i *)(pt + 12)); 
	a = SWAP32(a); b = SWAP32(b);
	c = SWAP32(c); d = SWAP32(d); 
	for (i = 0; i < RoundBallet128128; i += 2)
	{
		t0 = b ^ c;
		b ^= (*(trk + 1));
		c ^= (*trk);
		b = ROTL32(b, 6);
		d = ROTL32(d, 15);
		a = ROTL32(a, 6);
		a += ROTL32(t0, 9);
		d += ROTL32(t0, 14);
		t0 = a ^ d;
		b += ROTL32(t0, 9);
		d ^= (*(trk + 2));
		a ^= (*(trk + 3));
		c = ROTL32(c, 15);
		c += ROTL32(t0, 14);
		trk += 4;
	}
	*((u32i *)out) = SWAP32(b);
	*((u32i *)(out + 4)) = SWAP32(a);
	*((u32i *)(out + 8)) = SWAP32(d);
	*((u32i *)(out + 12)) = SWAP32(c);
}
