#include <stdio.h>
#include <string.h>
#ifdef __cplusplus
extern "C" {
#endif
#include "Ballet128256.h" 
#ifdef __cplusplus
}
#endif   


#define blocksize 128
#define keysize 256
void TestBallet128256_CBC(void);

int main()
{ 
	u8i _C_ALIGN32(ciphertext[256]);
	u8i _C_ALIGN32(plaintext[256]);
	u8i _C_ALIGN32(masterkey[32]);
	int i;
	int out_len;
	int in_len= blocksize/8;
	int keylen=keysize/8; 
	int round;
	memset(masterkey, 0, 32);
	memset(plaintext, 0, 32);
  //GenSampleTxt();
		plaintext[7]=1;
		plaintext[11]=2;
		plaintext[15]=3;    
		masterkey[7]=4;
		masterkey[15]=5;
		masterkey[23]=6;
		masterkey[31]=7; 
		round=RoundBallet128256;
	 

	printf("Ballet-%03d/%03d test vector:\n",blocksize,keysize );
	printf("masterkey is:\n");
	for(  i=0;i<keylen;i++)
		printf("%02X ", masterkey[i]);
	printf("\n"); 
	printf("encryption process:\n");
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");  
	printf("\n");  
#ifdef OutputInnerPars
	for(i=1;i<=round;i++)
	{
		Crypt_Enc_Block_Round(plaintext, in_len,ciphertext,&out_len, masterkey, keylen,i);
		 
	}
	printf("\n");
#endif
	Crypt_Enc_Block(plaintext,in_len, ciphertext, &out_len,  masterkey ,  keylen);

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  

	printf("decrption process:\n");

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  
	Crypt_Dec_Block(ciphertext,256, plaintext, &out_len,  masterkey ,  keylen);
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");     
	getchar();
	TestBallet128256_CBC();
	getchar();
	return 0;
} 


void TestBallet128256_CBC(void)
{
	u8i _C_ALIGN16(pl[256]);
	u8i _C_ALIGN16(MK[32]);
	u8i _C_ALIGN16(ref[256]) = {
0x43,0xA6,0x45,0xC0,0xC9,0xE8,0x78,0x7E,0xE3,0x66,0x72,0x10,0xB1,0xED,0x07,0xA8
,0xE9,0xE4,0x59,0xA0,0xD7,0xF1,0x13,0x93,0xF4,0x76,0x6B,0xCE,0xA9,0x51,0x3F,0x62
,0x67,0xBC,0x96,0x2C,0x4B,0x48,0xEC,0x4F,0xDE,0x49,0xCE,0x9D,0x78,0x6F,0x9F,0xAE
,0xEB,0x89,0x77,0xC1,0x48,0xF7,0x1B,0x60,0x69,0xFE,0x81,0x91,0x24,0x4B,0xDF,0x28
,0x17,0x20,0x5C,0x51,0x12,0xCF,0x8A,0x95,0x6E,0x18,0x9A,0x95,0x48,0x77,0x73,0x6F
,0x6F,0xE6,0x2E,0x06,0x66,0xB3,0x94,0x31,0xB9,0x09,0x38,0x60,0xF6,0xB1,0x06,0x50
,0x88,0xE6,0x51,0x9C,0x7A,0x46,0x71,0x22,0x2C,0x99,0xB2,0xD9,0xDF,0x17,0x1C,0xA4
,0x2A,0x74,0xD8,0x42,0xEC,0x16,0x3B,0x45,0x3E,0xE9,0xD2,0x5B,0x28,0xAD,0xA7,0xBB
,0xDB,0x09,0x18,0x9C,0xAB,0xFC,0x57,0xEA,0x52,0x6B,0xCB,0x1C,0x33,0xD4,0xAA,0x8B
,0x05,0x2E,0x1C,0x0F,0xCE,0x7F,0xF9,0xE2,0xE5,0xC5,0xFC,0x86,0x72,0x70,0x6C,0x27
,0x5A,0x97,0x95,0xB3,0x69,0x51,0x16,0x79,0xC4,0x98,0xFA,0x44,0x58,0x9F,0x5C,0x45
,0xED,0x2E,0x14,0x46,0xC5,0x85,0x01,0xA5,0x74,0x52,0x91,0x80,0x4B,0xEA,0xA9,0x6F
,0xA3,0x85,0x1D,0x50,0x5D,0xEB,0xF4,0x9E,0xD0,0x02,0x9A,0x8B,0x16,0x69,0xCB,0x95
,0xBD,0x9B,0x22,0xBA,0x3E,0x74,0x3F,0xB0,0x5C,0x12,0xD1,0x22,0xED,0x63,0x16,0xFC
,0x4B,0x33,0x0C,0xF6,0x16,0x33,0xF6,0x76,0xED,0x37,0x1D,0xB4,0xD5,0x11,0x77,0x5C
,0x18,0xC0,0xF6,0xF7,0xC8,0x0B,0xCE,0x04,0x1B,0x89,0x78,0x91,0x9E,0x1F,0x79,0x5E };
	u8i _C_ALIGN16(out[256]);
	u8i _C_ALIGN16(rev[256]);
	int i;
	int out_len;
	memset(pl, 0, 256);
	memset(MK, 0, 32);
	MK[7] = 12;
	MK[15] = 13;
	MK[23] = 14;
	MK[31] = 15;
	for (i = 0; i < 256 / 4; i++)
		pl[i * 4 + 3] = i;
	printf("Ballet-128/256 test vector:\n");
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", pl[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf(" mk    \n");   for (i = 0; i < 16; i++)      printf("%02X ", MK[i]);  printf("\n");
	printf("ciphertext is:\n");
	memset(out, 0, 256);
	Crypt_Enc_Block_CBC(pl, 256, out, &out_len, MK, 32);
	printf(" cy   \n");    for (i = 0; i < 256; i++) { printf("%02X ", out[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(out, ref, 256) ? "FAIL" : "PASS");
	printf("decrption process:\n");
	Crypt_Dec_Block_CBC(out, 256, rev, &out_len, MK, 32);
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", rev[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(pl, rev, 256) ? "FAIL" : "PASS");
}