#include "Ballet256256_coreD.h"

static  const unsigned char _C_ALIGN32(Lbswap_mask[32]) = {
	  7, 6, 5,4, 3, 2, 1, 0,  15, 14, 13, 12,11, 10, 9, 8,7, 6, 5,4, 3, 2, 1, 0,  15, 14, 13, 12,11, 10, 9, 8,
};
static  const unsigned char _C_ALIGN32(Lbswap_maskb[32]) = {
	  15, 14, 13, 12,11, 10, 9, 8, 7, 6, 5,4, 3, 2, 1, 0,15, 14, 13, 12,11, 10, 9, 8, 7, 6, 5,4, 3, 2, 1, 0,
};



#define ROTL64_AVX2(a,n)\
_mm256_or_si256( _mm256_slli_epi64(a, n),_mm256_srli_epi64(a, 64-n))

#define ROTR64_AVX2(a,n)\
_mm256_or_si256( _mm256_srli_epi64(a, n),_mm256_slli_epi64(a, 64-n)) 
 
#define BalletLoadData256(D0,D1,D2,D3,pt,E0,E1,E2,E3)\
      D0= _mm256_loadu_si256((__m256i*)(pt));\
      D1= _mm256_loadu_si256((__m256i*)(pt+32)); \
      D2= _mm256_loadu_si256((__m256i*)(pt+32*2)); \
      D3= _mm256_loadu_si256((__m256i*)(pt+32*3)); \
    D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
     E0=  _mm256_unpacklo_epi64(D0, D2);\
     E1=  _mm256_unpackhi_epi64(D0, D2);\
     E2=  _mm256_unpacklo_epi64(D1, D3);\
     E3=  _mm256_unpackhi_epi64(D1, D3);\
     D0= _mm256_permute2x128_si256(E0,E2, 0x20);\
     D2= _mm256_permute2x128_si256(E0, E2, 0x31);\
     D1= _mm256_permute2x128_si256(E1,E3, 0x20);\
     D3= _mm256_permute2x128_si256(E1, E3, 0x31);



#define BalletOutputData256(D0,D1,D2,D3,p,E0,E1,E2,E3)\
     E0= _mm256_permute2x128_si256(D0,D2, 0x20);\
     E2= _mm256_permute2x128_si256(D0, D2, 0x31);\
     E1= _mm256_permute2x128_si256(D1,D3, 0x20);\
     E3= _mm256_permute2x128_si256(D1, D3, 0x31);\
     D0=  _mm256_unpacklo_epi64(E0, E1);\
     D2=  _mm256_unpackhi_epi64(E0, E1);\
     D1=  _mm256_unpacklo_epi64(E2, E3);\
     D3=  _mm256_unpackhi_epi64(E2, E3);\
    D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_maskb  ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
	 _mm256_storeu_si256((__m256i*)(p  ), D0);\
    _mm256_storeu_si256((__m256i*)(p+32*1), D1);\
     _mm256_storeu_si256((__m256i*)(p +32*2 ), D2);\
    _mm256_storeu_si256((__m256i*)(p+32*3), D3); 	 


#define BalletRFDecB(a,b,c,d,t0,t1,t2,t3,p)\
	  b=_mm256_xor_si256(b,*(p+1) ); \
	  c=_mm256_xor_si256(c,*(p)); \
	  t0 = _mm256_xor_si256(b,c);\
	  a=  _mm256_sub_epi64(a, ROTL64_AVX2(t0, 9));\
	  d=  _mm256_sub_epi64(d, ROTL64_AVX2(t0, 14));\
	  a=  ROTR64_AVX2(a,6);\
	  d= ROTR64_AVX2(d,15);\
	  d=_mm256_xor_si256(d,*(p+2) ); \
	  a=_mm256_xor_si256(a,*(p+3) );\
	  t3 = _mm256_xor_si256(a,d);\
	  b=  _mm256_sub_epi64(b, ROTL64_AVX2(t3, 9));\
	  b = ROTR64_AVX2(b,6);\
	  c=  _mm256_sub_epi64(c, ROTL64_AVX2(t3, 14));\
	  c =ROTR64_AVX2(c, 15) ;

void BalletGenRK_256_256M_DEC(__m256i * Rk, u8i * K )
{
	u64i i;
	u64i  k00, k01, k10, k11;
	__m256i *p = Rk;
	k01 = *((u64i *)K);
	k00 = *((u64i *)(K + 8));
	k11 = *((u64i *)(K + 16));
	k10 = *((u64i *)(K + 24));

	k00 = SWAP64(k00);
	k01 = SWAP64(k01);
	k10 = SWAP64(k10);
	k11 = SWAP64(k11);
 
		p += (RoundBallet256256 * 2 - 1);
		for (i = 0; i < RoundBallet256256; i += 2)
		{
			*(p - 1) = _mm256_set1_epi64x(k00);
			*(p) = _mm256_set1_epi64x(k01); 
			k00 ^= ((k10 << 3) | (k11 >> 61)) ^ ((k10 << 5) | (k11 >> 59)) ^ i;
			k01 ^= ((k11 << 3) | (k10 >> 61)) ^ ((k11 << 5) | (k10 >> 59));
			*(p - 3) = _mm256_set1_epi64x(k10);
			*(p - 2) = _mm256_set1_epi64x(k11); 
			k10 ^= ((k00 << 3) | (k01 >> 61)) ^ ((k00 << 5) | (k01 >> 59)) ^ (i + 1);
			k11 ^= ((k01 << 3) | (k00 >> 61)) ^ ((k01 << 5) | (k00 >> 59));
			p -= 4;
		} 
} 

void Ballet256256DecDataM(unsigned char *out, unsigned char *pt, unsigned char *trk)
{
	__m256i *p = (__m256i *)trk;
	__m256i *dst = p + RoundBallet256256 * 2;
	__m256i D0, D1, D2, D3, D4, D5, D6, D7;
	__m256i E0, E1, E2, E3;
	BalletLoadData256(D0, D1, D2, D3, pt, E0, E1, E2, E3);
	BalletLoadData256(D4, D5, D6, D7, pt + 128, E0, E1, E2, E3);

	for (; p < dst; p += 4)
	{
		BalletRFDecB(D0, D1, D2, D3, E0, E1, E2, E3, p);
		BalletRFDecB(D4, D5, D6, D7, E0, E1, E2, E3, p); 
	} 
	BalletOutputData256(D0, D1, D2, D3, out, E0, E1, E2, E3);
	BalletOutputData256(D4, D5, D6, D7, out + 16 * 8, E0, E1, E2, E3);
}
  

#define BalletOutputData256A(D0,D1,D2,D3,E0,E1,E2,E3)\
     E0= _mm256_permute2x128_si256(D0,D2, 0x20);\
     E2= _mm256_permute2x128_si256(D0, D2, 0x31);\
     E1= _mm256_permute2x128_si256(D1,D3, 0x20);\
     E3= _mm256_permute2x128_si256(D1, D3, 0x31);\
     D0=  _mm256_unpacklo_epi64(E0, E1);\
     D2=  _mm256_unpackhi_epi64(E0, E1);\
     D1=  _mm256_unpacklo_epi64(E2, E3);\
     D3=  _mm256_unpackhi_epi64(E2, E3);\
    D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_maskb  ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_maskb )); 

void Ballet256256DecDataM_CBC(unsigned char *out, unsigned char *pt, unsigned char *trk, __m256i *IV)
{	 
	__m256i *p = (__m256i *)trk;
	__m256i *dst = p + RoundBallet256256 * 2;
	__m256i D0, D1, D2, D3, D4, D5, D6, D7;
	__m256i E0, E1, E2, E3, E4, E5, E6, E7;
	BalletLoadData256(D0, D1, D2, D3, pt, E0, E1, E2, E3);
	BalletLoadData256(D4, D5, D6, D7, pt + 128, E0, E1, E2, E3);

	for (; p < dst; p += 4)
	{
		BalletRFDecB(D0, D1, D2, D3, E0, E1, E2, E3, p);
		BalletRFDecB(D4, D5, D6, D7, E0, E1, E2, E3, p);
	}
	 
	E4 = *IV;
	E5 = _mm256_loadu_si256((__m256i*)(pt));
	E6 = _mm256_loadu_si256((__m256i*)(pt + 32));
	E7 = _mm256_loadu_si256((__m256i*)(pt + 32*2));

	BalletOutputData256A(D0, D1, D2, D3, E0, E1, E2, E3);
	_mm256_storeu_si256((__m256i*)(out), _mm256_xor_si256(D0, E4));
	_mm256_storeu_si256((__m256i*)(out + 32), _mm256_xor_si256(D1, E5));
	_mm256_storeu_si256((__m256i*)(out + 32 * 2), _mm256_xor_si256(D2, E6));
	_mm256_storeu_si256((__m256i*)(out + 32 * 3), _mm256_xor_si256(D3, E7));

	E4 = _mm256_loadu_si256((__m256i*)(pt + 32*3));
	E5 = _mm256_loadu_si256((__m256i*)(pt + 32 * 4));
	E6 = _mm256_loadu_si256((__m256i*)(pt + 32 * 5));
	E7 = _mm256_loadu_si256((__m256i*)(pt + 32 * 6));
	*IV = _mm256_loadu_si256((__m256i*)(pt + 32 * 7));

	BalletOutputData256A(D4, D5, D6, D7, E0, E1, E2, E3);
	_mm256_storeu_si256((__m256i*)(out + 32 * 4), _mm256_xor_si256(D4, E4));
	_mm256_storeu_si256((__m256i*)(out + 32 * 5), _mm256_xor_si256(D5, E5));
	_mm256_storeu_si256((__m256i*)(out + 32 * 6), _mm256_xor_si256(D6, E6));
	_mm256_storeu_si256((__m256i*)(out + 32 * 7), _mm256_xor_si256(D7, E7));
}
