#include <stdio.h>
#include <string.h>
#ifdef __cplusplus
extern "C" {
#endif
#include "Ballet256256.h"    
#ifdef __cplusplus
}
#endif   

#define blocksize 256
#define keysize 256

void TestBallet256256_CBC(void);

int main()
{ 
u8i ciphertext[32];
	u8i plaintext[32];
	u8i masterkey[32]; 
	int i;
	int out_len;
	int in_len=blocksize/8;
	int keylen=keysize/8; 
	int round;
	memset(masterkey, 0, 32);
	memset(plaintext, 0, 32);
 
// GenSampleTxt();
		plaintext[15]=1;
		plaintext[23]=2;
		plaintext[31]=3;   

		masterkey[7]=0;
		masterkey[15]=4;
		masterkey[23]=0;
		masterkey[31]=5;  
		round=RoundBallet256256;
	 

	printf("Ballet-%03d/%03d test vector:\n",blocksize,keysize );
	printf("masterkey is:\n");
	for(  i=0;i<keylen;i++)
		printf("%02X ", masterkey[i]);
	printf("\n"); 
	printf("encryption process:\n");
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");  
	printf("\n"); 
#ifdef OutputInnerPars
	for(i=1;i<=round;i++)
	{
		Crypt_Enc_Block_Round(plaintext, in_len,ciphertext,&out_len, masterkey, keylen,i);
		 
	}
	printf("\n");
#endif
	Crypt_Enc_Block(plaintext,in_len, ciphertext, &out_len,  masterkey ,  keylen);

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  

	printf("decrption process:\n");

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  
	Crypt_Dec_Block(ciphertext,in_len, plaintext, &out_len,  masterkey ,  keylen);
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");     
	getchar();
	TestBallet256256_CBC();
	getchar();

	return 0;
} 


void TestBallet256256_CBC(void)
{
	u8i _C_ALIGN32(pl[256]);
	u8i _C_ALIGN32(MK[32]);
	u8i _C_ALIGN32(ref[256]) = {
0x89,0xD3,0xEA,0x28,0x62,0x4C,0x4C,0xEF,0x28,0x0B,0xE3,0x8B,0x56,0x6F,0xCF,0x7A,0x95,0x78,0x98,0x56,0xB1,0xC0,0xC1,0x31,0x75,0xCE,0x2D,0x91,0xA6,0xF8,0xC8,0xF3
,0x34,0x15,0xC1,0x3B,0x5D,0xC2,0x22,0x8D,0x94,0x7F,0x1E,0xDF,0x15,0xE1,0x39,0x99,0x11,0x79,0x66,0x36,0x68,0x63,0xE7,0x78,0xDC,0xCB,0xCF,0x64,0xC3,0xB7,0x41,0x8B
,0x4B,0x3D,0x9E,0xA4,0x20,0xD1,0x35,0xCE,0x68,0x90,0xF3,0xBE,0xB8,0x52,0x3A,0x60,0x0B,0xF2,0x6F,0x3B,0x8F,0x29,0x7B,0x45,0x39,0xCD,0x4E,0x64,0xD8,0xC1,0x32,0x77
,0x8C,0x16,0x87,0x64,0x05,0x54,0x53,0x03,0x7D,0xD3,0xD5,0x38,0x22,0x56,0x5D,0xC5,0x87,0x6D,0xD1,0x9A,0x3F,0x7A,0x0D,0x1C,0x36,0x01,0x26,0xAF,0x1B,0x50,0xBF,0x42
,0x2A,0x6B,0xE5,0x20,0x24,0xAC,0x12,0x2A,0x32,0x8D,0xE8,0x9C,0x30,0x5A,0x5B,0x28,0x8D,0xD9,0xEC,0xEC,0xB1,0x4C,0x7B,0x40,0x18,0x77,0xB3,0xBD,0x06,0xDC,0x2C,0x38
,0xB3,0x02,0xC3,0xB8,0x2F,0x0A,0xCD,0xA0,0x9E,0x29,0xE7,0x26,0xB0,0xD6,0x64,0x78,0x25,0x28,0x36,0x99,0xD9,0x64,0x7C,0x9E,0xC7,0xC5,0x49,0x3D,0xF1,0x80,0x6C,0x07
,0x4A,0x25,0x00,0x25,0x6A,0xA3,0x91,0xD6,0x0B,0x69,0x7F,0xA3,0x3E,0x13,0x5E,0xE2,0x57,0xE6,0x9A,0x80,0x2B,0x82,0xC7,0x19,0x36,0x24,0x31,0x90,0x4D,0xF4,0x65,0x3C
,0xD7,0xAE,0xBB,0xFE,0x07,0xAC,0x00,0x03,0xC9,0x77,0xE4,0x81,0x66,0x81,0xFF,0x7E,0x5F,0x52,0xB8,0xD2,0x0E,0xA4,0x68,0x1F,0x5B,0x92,0x91,0x96,0x57,0xFE,0x16,0x16 };
	u8i _C_ALIGN32(out[256]);
	u8i _C_ALIGN32(rev[256]);
	int i;
	int out_len;
	memset(pl, 0, 256);
	memset(MK, 0, 32);
	//MK[7] = 12;
	//MK[15] = 13;
	 MK[15] = 12;
	 MK[31] = 13;
	for (i = 0; i < 256 / 8; i++)
		pl[i * 8 + 7] = i;
	printf("Ballet-256/256 test vector:\n");
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", pl[i]);  	if ((i + 1) % 32 == 0) printf("\n"); }
	printf(" mk    \n");   for (i = 0; i < 32; i++)      printf("%02X ", MK[i]);  printf("\n");
	printf("ciphertext is:\n");
	memset(out, 0, 256);
	Crypt_Enc_Block_CBC(pl, 256, out, &out_len, MK, 32);
	printf(" cy   \n");    for (i = 0; i < 256; i++) { printf("%02X ", out[i]);  	if ((i + 1) % 32 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(out, ref, 256) ? "FAIL" : "PASS");
	printf("decrption process:\n");
	Crypt_Dec_Block_CBC(out, 256, rev, &out_len, MK, 32);
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", rev[i]);  	if ((i + 1) % 32 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(pl, rev, 256) ? "FAIL" : "PASS");
}